<cfimport prefix="layout" taglib="./layout" />
<layout:layout>
<cfscript>
	collection = application.mongo.getDBCollection( "sessions" );
	AggregationPipeline = [];
	/*Define filter steps*/
	GroupByPresenters_CountSessions = {"$group"= {"_id"= {"PRESENTER"= "$PRESENTER", "CONTACT"= "$CONTACT"}, "sessioncount"= {"$sum"=1 }}};
	ReformatTheDocument = {"$project"= {"_id"="$_id.PRESENTER", "contact"="$_id.CONTACT", "sessioncount"= "$sessioncount"}};
	SortByPresenter = {"$sort"= {"PresentationCount"=-1}};
	/*add pipeline steps to the pipeline array*/
	arrayAppend( AggregationPipeline, GroupByPresenters_CountSessions);
	arrayAppend( AggregationPipeline, ReformatTheDocument);
	arrayAppend( AggregationPipeline, SortByPresenter);

	result = collection.aggregate(AggregationPipeline);
	SpeakerArray = result.asArray();
</cfscript>

<cfoutput>
<div class="row">
<cfloop array="#SpeakerArray#" index="thisSpeaker">

    <div class="col-6 col-sm-6 col-lg-4 panel ">
        <h2><a href="PresenterDisplay.cfm?PRESENTER=#thisSpeaker._id#">#thisSpeaker._id#</a></h2>
		<h4>Presentations: #thisSpeaker.sessioncount#</h4>
		<ul>
			<cfloop array="#thisSpeaker.contact#" index="thisContact">
				<li>#thisContact#</li>
			</cfloop>
		</ul>
	</div>
</cfloop>
</div>
</cfoutput>

<!---<cfscript>
	writedump(var:result.asArray(),label:"result.asArray() : Counts Using Group By");
    writeOutput("<p></p>");
	writedump(var:result.getCommand(),label:"result.getCommand()");
    writeOutput("<p></p>");
	writedump(var:result.getAggregationOutput(),label:"result.getAggregationOutput()");
    writeOutput("<p></p>");
</cfscript>--->
</layout:layout>