<cfimport prefix="layout" taglib="./layout" />
<layout:layout>
<cfscript>
	collection = application.mongo.getDBCollection( "sessions" );
	AggregationPipeline = [];

	/*Define filter steps*/
	GroupByPresenters_CountSessions = {"$group"= {"_id"= {"PRESENTER"= "$PRESENTER", "CONTACT"= "$CONTACT"}, "sessioncount"= {"$sum"=1 }}};
	ReformatTheDocument = {"$project"= {"_id"="$_id.PRESENTER", "contact"="$_id.CONTACT", "sessioncount"= "$sessioncount"}};
	GroupByPresentationCount_CountSpeakers = {"$group"= {"_id"="$sessioncount", "numberofspeakers"= {"$sum"=1 }, "speakerArray"= {"$addToSet"= "$_id"}}};
	SortByPresenter = {"$sort"= {"_id"=-1}};

	/*add pipeline steps to the pipeline array*/
	arrayAppend( AggregationPipeline, GroupByPresenters_CountSessions);
	arrayAppend( AggregationPipeline, ReformatTheDocument);
	arrayAppend( AggregationPipeline, GroupByPresentationCount_CountSpeakers);
	arrayAppend( AggregationPipeline, SortByPresenter);
	SpeakerDistribution = collection.aggregate(AggregationPipeline).asArray();
</cfscript>

<cfoutput>
<cfloop array="#SpeakerDistribution#" index="thisPresentationCount">
	<h2>Presentation Count: #thisPresentationCount._id#</h2>
	<h4>Speakers: #thisPresentationCount.numberofspeakers#</h4>
	<ul>
		<cfloop array="#thisPresentationCount.speakerArray#" index="thisSpeaker">
		<li><a href="PresenterDisplay.cfm?PRESENTER=#thisSpeaker#">#thisSpeaker#</a></li>
		</cfloop>
	</ul>
</cfloop>
</cfoutput>
</layout:layout>