<cfimport prefix="layout" taglib="./layout" />
<layout:layout>
<cfscript>
	collection = application.mongo.getDBCollection( "sessions" );
	AggregationPipeline = [];

	/*Define filter steps*/
	Unwind_Comments = {"$unwind"= "$COMMENTS"};
	GroupByPresenters_AverageRatings = {"$group"= {"_id"= "$PRESENTER", "averagerating"= {"$avg"="$COMMENTS.RATING" }}};
	GroupByPresentationCount_FilterNoRatings = {"$match"= {"averagerating"= {"$gt"= 0}}};
	SortByPresenter = {"$sort"= {"averagerating"=-1}};

	/*add pipeline steps to the pipeline array*/
	arrayAppend( AggregationPipeline, Unwind_Comments);
	arrayAppend( AggregationPipeline, GroupByPresenters_AverageRatings);
	arrayAppend( AggregationPipeline, GroupByPresentationCount_FilterNoRatings);
	arrayAppend( AggregationPipeline, SortByPresenter);
	SpeakerRatings = collection.aggregate(AggregationPipeline).asArray();
</cfscript>

<h1>Speaker Ratings</h1>
<cfoutput>
<cfloop array="#SpeakerRatings#" index="thisSpeaker">
	<h2>#thisSpeaker._id#: <span class="badge">#thisSpeaker.averagerating# average</span></h2>
</cfloop>
</cfoutput>
</layout:layout>