<cfimport prefix="layout" taglib="./layout" />
<layout:layout>
<cfscript>
	collection = application.mongo.getDBCollection( "sessions" );
	AggregationPipeline = [];

	/*Define filter steps*/
	GroupByTrack_SumCheckin = {"$group"= {"_id"= "$TRACK", "checkincount"= {"$sum"="$CHECKINS" }}};
	SortByPopularity = {"$sort"= {"checkincount"=-1}};

	/*add pipeline steps to the pipeline array*/
	arrayAppend( AggregationPipeline, GroupByTrack_SumCheckin);
	arrayAppend( AggregationPipeline, SortByPopularity);
	TrackReport = collection.aggregate(AggregationPipeline).asArray();
</cfscript>

<h1>Track Ratings</h1>
<cfoutput>
<cfloop array="#TrackReport#" index="thisTrack">
	<h2>#thisTrack._id#: <span class="badge">#thisTrack.checkincount# checkins</span></h2>
</cfloop>
</cfoutput>
</layout:layout>